.586
.model flat,stdcall
option casemap:none

include windows.inc 
   
include user32.inc 
include kernel32.inc 
include masm32.inc
include winmm.inc
   
includelib user32.lib 
includelib kernel32.lib
includelib masm32.lib
includelib winmm.lib 

include C:\masm32\macros\macros.asm

include d3d9_.inc
include d3dx9math_.inc
include d3dx9core_.inc
include d3d9caps_.inc
include d3d9types_.inc

includelib d3d9.lib
includelib d3dx9.lib

WinMain proto :DWORD,:DWORD,:DWORD,:DWORD

InitD3D       proto 
InitGeometry  proto
Cleanup       proto
SetupMatrices proto
Render        proto

.const
D3DFVF_CUSTOMVERTEX equ D3DFVF_XYZ OR D3DFVF_DIFFUSE

.data?
hInstance HINSTANCE ?
CommandLine LPSTR ?
hWnd HWND ?

CUSTOMVERTEX struct
	x     real4 ? 
	y     real4 ?
	z     real4 ?
	color dword ? 
CUSTOMVERTEX ends

.data
ClassName db "MainWinClass",0
AppName  db "Main Window",0

sIID_IDirect3D9  TEXTEQU  <{081BDCBCAH,064D4H,0426DH,{0AEH,08DH,0ADH,01H,047H,0F4H,027H,05CH}}>
IID_IDirect3D9 GUID <081BDCBCAH,064D4H,0426DH,<0AEH,08DH,0ADH,01H,047H,0F4H,027H,05CH>>

sIID_IDirect3DDevice9  TEXTEQU  <{0D0223B96H,0BF7AH,043FDH,{092H,0BDH,0A4H,03BH,0DH,082H,0B9H,0EBH}}>
IID_IDirect3DDevice9 GUID <0D0223B96H,0BF7AH,043FDH,<092H,0BDH,0A4H,03BH,0DH,082H,0B9H,0EBH>>

sIID_IDirect3DVertexBuffer9  TEXTEQU  <{0B64BB1B5H,0FD70H,04DF6H,{0BFH,091H,019H,0D0H,0A1H,024H,055H,0E3H}}>
IID_IDirect3DVertexBuffer9 GUID <0B64BB1B5H,0FD70H,04DF6H,<0BFH,091H,019H,0D0H,0A1H,024H,055H,0E3H>>

COM pd3d,IDirect3D9
COM pd3ddevice,IDirect3DDevice9
COM pvb,IDirect3DVertexBuffer9

;Initialize three vertices for rendering a triangle
Vertices CUSTOMVERTEX { -1.0,-1.0, 0.0, 0ffff0000H },
                      {  1.0,-1.0, 0.0, 0ff0000ffH },
                      {  0.0, 1.0, 0.0, 0ffffffffH }

vEyePt    D3DXVECTOR3 { 0.0, 3.0,-5.0 }
vLookatPt D3DXVECTOR3 { 0.0, 0.0, 0.0 }
vUpVec    D3DXVECTOR3 { 0.0, 1.0, 0.0 }

var2     real4    2.0
var3     real4 1000.0
var4     real4    1.0
var5     real4  100.0
D3DX_PI  real4 3.141592654
D3DX_PI4 real4 0.7853981635

.code

start:
	invoke GetModuleHandle, NULL
	mov    hInstance,eax
	
	invoke GetCommandLine
	mov    CommandLine,eax
	
	invoke WinMain, hInstance,NULL,CommandLine, SW_SHOWDEFAULT
	invoke ExitProcess,eax

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG
	LOCAL hWndParent:DWORD
	
	invoke GetDesktopWindow
	mov hWndParent,eax
	
	mov   wc.cbSize,SIZEOF WNDCLASSEX
	mov   wc.style, CS_CLASSDC
	mov   wc.lpfnWndProc, OFFSET WndProc
	mov   wc.cbClsExtra,NULL
	mov   wc.cbWndExtra,NULL
	push  hInstance
	pop   wc.hInstance
	mov   wc.hbrBackground,NULL
	mov   wc.lpszMenuName,NULL
	mov   wc.lpszClassName,OFFSET ClassName
	
	invoke LoadIcon,NULL,IDI_APPLICATION
	mov   wc.hIcon,eax
	mov   wc.hIconSm,eax
	
	invoke LoadCursor,NULL,IDC_ARROW
	mov   wc.hCursor,eax
	
	invoke RegisterClassEx, addr wc
	INVOKE CreateWindowEx,NULL,ADDR ClassName,ADDR AppName,\
           WS_OVERLAPPEDWINDOW,100,\
           100,256,256,hWndParent,NULL,\
           hInst,NULL
	mov   hWnd,eax
	
	invoke InitD3D
	.if eax==S_OK
		invoke InitGeometry
		.if eax==S_OK
			invoke ShowWindow, hWnd,SW_SHOWNORMAL
	        invoke UpdateWindow, hWnd
	        invoke RtlZeroMemory,addr msg,sizeof msg
	        .while msg.message!=WM_QUIT
	        	invoke PeekMessage,addr msg,NULL,0,0,PM_REMOVE
	        	.if (eax)
	        	    invoke TranslateMessage,addr msg
	        	    invoke DispatchMessage,addr msg
	        	    .else
	        	    	invoke Render
	        	.endif
	        .endw
		.endif
	.endif
	
	mov     eax,msg.wParam
	ret
WinMain endp

WndProc proc hwnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	
	.IF uMsg==WM_DESTROY
	    invoke Cleanup
		invoke PostQuitMessage,NULL
	.ELSEIF uMsg==WM_CREATE
		;
	.ELSE
		invoke DefWindowProc,hwnd,uMsg,wParam,lParam		
		ret
	.ENDIF
	
	xor eax,eax
	ret
WndProc endp

InitD3D proc
LOCAL  d3dpp:D3DPRESENT_PARAMETERS

    ;Create the D3D object.
    invoke Direct3DCreate9,D3D_SDK_VERSION
    mov pd3d,eax
    
    ;Set up the structure used to create the D3DDevice
	invoke RtlZeroMemory,addr d3dpp,sizeof d3dpp
	mov d3dpp.Windowed,TRUE
	mov d3dpp.SwapEffect,D3DSWAPEFFECT_DISCARD
	mov d3dpp.BackBufferFormat,D3DFMT_UNKNOWN
	
	;Create the D3DDevice
	CINVOKE pd3d,CreateDevice,D3DADAPTER_DEFAULT,D3DDEVTYPE_HAL,hWnd,D3DCREATE_SOFTWARE_VERTEXPROCESSING,addr d3dpp,addr pd3ddevice 
    
    ;Turn off culling, so we see the front and back of the triangle
    CINVOKE pd3ddevice,SetRenderState,D3DRS_CULLMODE,D3DCULL_NONE
    
    ;Turn off D3D lighting, since we are providing our own vertex colors
    CINVOKE pd3ddevice,SetRenderState,D3DRS_LIGHTING,FALSE
	
	return S_OK
InitD3D endp

InitGeometry proc
LOCAL pVertices:DWORD

	;Create the vertex buffer
	CINVOKE pd3ddevice,CreateVertexBuffer,(3*sizeof CUSTOMVERTEX),0,D3DFVF_CUSTOMVERTEX,D3DPOOL_DEFAULT,addr pvb,NULL
	
	
	;Fill the vertex buffer
	CINVOKE pvb,_Lock,0,sizeof Vertices,addr pVertices,0
	
	invoke RtlMoveMemory,pVertices,offset Vertices,sizeof Vertices
	CINVOKE pvb,Unlock
	
	return S_OK
InitGeometry endp

Cleanup proc

    .if pd3d!=0
    	CINVOKE pd3d,Release
    .endif	
    .if pd3ddevice!=0
    	CINVOKE pd3ddevice,Release
    .endif
    .if pvb!=0
    	CINVOKE pvb,Release
    .endif
	
	ret
Cleanup endp

SetupMatrices proc
LOCAL matWorld:D3DXMATRIX
LOCAL matView:D3DXMATRIX
LOCAL matProj:D3DXMATRIX
LOCAL iTime:DWORD
LOCAL fAngle:REAL4
LOCAL var1:DWORD
    
    ;For our world matrix, we will just rotate the object about the y-axis
	;Set up the rotation matrix to generate 1 full rotation (2*PI radians)
    ;every 1000 ms. To avoid the loss of precision inherent in very high
    ;floating point numbers, the system time is modulated by the rotation
    ;period before conversion to a radian angle.
    mov var1,1000
    invoke timeGetTime
    div var1
    xor edx,edx
    div var1
    mov iTime,edx
    
    fild iTime
    fmul var2
    fmul D3DX_PI
    fdiv var3
    fst fAngle
	
	invoke D3DXMatrixRotationY,addr matWorld,fAngle
	CINVOKE pd3ddevice,SetTransform,D3DTS_WORLD,addr matWorld
	
	;Set up our view matrix. A view matrix can be defined given an eye point,
    ;a point to lookat, and a direction for which way is up. Here, we set the
    ;eye five units back along the z-axis and up three units, look at the
    ;origin, and define "up" to be in the y-direction.
	invoke D3DXMatrixLookAtLH,addr matView,offset vEyePt,offset vLookatPt,offset vUpVec
	CINVOKE pd3ddevice,SetTransform,D3DTS_VIEW,addr matView
	
	;For the projection matrix, we set up a perspective transform (which
    ;transforms geometry from 3D view space to 2D viewport space, with
    ;a perspective divide making objects smaller in the distance). To build
    ;a perpsective transform, we need the field of view (1/4 pi is common),
    ;the aspect ratio, and the near and far clipping planes (which define at
    ;what distances geometry should be no longer be rendered).
    invoke D3DXMatrixPerspectiveFovLH,addr matProj,D3DX_PI4,var4,var4,var5
    CINVOKE pd3ddevice,SetTransform,D3DTS_PROJECTION,addr matProj 
    
	ret
SetupMatrices endp

Render proc
	;Clear the backbuffer to a black color
	CINVOKE pd3ddevice,Clear,0,NULL,D3DCLEAR_TARGET,$D3DCOLOR_XRGB(0,0,0),var4,0
	
	;Begin the scene
	CINVOKE pd3ddevice,BeginScene
	
		;Setup the world, view, and projection matrices
		invoke SetupMatrices
		;Render the vertex buffer contents
		CINVOKE pd3ddevice,SetStreamSource,0,pvb,0,sizeof CUSTOMVERTEX
		CINVOKE pd3ddevice,SetFVF,D3DFVF_CUSTOMVERTEX
		CINVOKE pd3ddevice,DrawPrimitive,D3DPT_TRIANGLESTRIP,0,1 
	
	 CINVOKE pd3ddevice,EndScene
	 
	 ;Present the backbuffer contents to the display
	 CINVOKE pd3ddevice,Present,NULL,NULL,NULL,NULL
	
	ret
Render endp

end start














































